// --------------------------------------------------------
// SK_TEST
// Petit lanceur de requtes SQL perso (ralis  la maison)
// pour faciliter mes tests.
//
// Sad Koudache, le 29/05/2012
// --------------------------------------------------------

/*
v1.5 SK 23/04/2015 Notions de variables.
v1.4 SK 17/07/2014 Agrandi champs SQL   60000c
v1.3 SK 08/05/2013 Changement dans les tokens
v1.2 SK 18/04/2013 configuration dans fichier ini

TO_DO
 - copier automatiquement les fichiers  intgrer au bon endroit dans UR\in ou intgration
 - intgrer automatiquement les fichiers via ANT
 - pouvoir lancer une chaine ordonne de scnario : ex : tout le back office
 - rapport HTML ou Word plus clean, graphiques  ...
*/

#include <stdio.h>
#include <string.h>
#include <io.h>

#include <windows.h>
#include <assert.h>
#include <time.h>

#include <ocilib.h>

#define VERSION "v1.5"

#define TRAIT 110

// prpa BDD prsence des tickets

OCI_Connection * cn;

OCI_Statement * st;
OCI_Resultset * rs;

int nb_OK_sce,
nb_KO_sce,
nb_OK,
nb_KO;
int nb_sce = 0;
int nb_tests;

int no_ligne = 0;  // n de ligne dans le fichier scnario en cours de traitement

char Separateur = '|';

#define MAX_LIG_SCE 60000

typedef struct
{
    char application [100];
    char client [100];
    char title [100];
    char titre_global [100];
    char cnx_bdd [100];
    char rep_data_in [250];
    char rep_wst_outgoing [250];
    char rep_wst_integration [250];
    char rep_wst_incomming [250];
}
T_DECLARE;

T_DECLARE d;

typedef struct
{
    char test_id [100];
    char test_lib [100];
    char result [100];
    char SQL_resultI [MAX_LIG_SCE];
    char SQL_resultS [MAX_LIG_SCE];
    char SQL_resultX [MAX_LIG_SCE];
    char assert [100];
}
T_RUN;
T_RUN r;

FILE * flog;
FILE * fsce;

typedef struct
{
    char nom_variable [30];
    char valeur [200];
} T_VARIABLE;

T_VARIABLE liste_var [100];
int nb_var = 0;


char * chaine_guillemets (char * s)
{
   static char sresult [1000];
   char * ps, * pdest;

   pdest = sresult;
   ps = s;
   while (*ps)
   {
      *pdest++ = *ps;

      if ((*ps) == '\'')
      {
         *pdest++ = '\'';
      }
      ps++;
   }

   *pdest = '\0';
   return (sresult);
}


// Gestion des variables
char * get_valeur_var (char * nom_variable)
{
   int i;
   char * a_rechercher;
   int guillemets = 0;

   a_rechercher = nom_variable;
   if (nom_variable [0] == '\'')
   {
      a_rechercher++;
      guillemets = 1;
   }

   for (i = 0; i < nb_var; i++)
      if (! strcmp(liste_var[i].nom_variable, a_rechercher) )
      {
         if (guillemets)
           return (chaine_guillemets(liste_var[i].valeur) );
         else
           return (liste_var[i].valeur);
      }



   return (NULL);
}

void set_valeur_var (char * nom_variable, char * valeur)
{
   int i;

   // tenter de mettre  jour une variable existante
   for (i = 0; i < nb_var; i++)
   {
      if (! strcmp(liste_var[i].nom_variable, nom_variable) )
      {
         strcpy (liste_var[i].valeur, valeur);
         return;
      }
   }

   strcpy (liste_var[nb_var].nom_variable, nom_variable);
   strcpy (liste_var[nb_var].valeur, valeur);
   nb_var++;
}


// Affichage sous dos avec accents
char * to_dos (char * s)
{
    static char OEM_string [500];

    CharToOem (s, OEM_string);
    return (OEM_string);
}

char * get_date_time (void)
{
    struct tm * t;
    time_t nbsec;
    static char s [20];

    time (&nbsec);
    t = localtime (&nbsec);

    sprintf (s, "%02d/%02d/%04d %02d:%02d:%02d", t->tm_mday, t->tm_mon + 1, t->tm_year + 1900, t->tm_hour, t->tm_min, t->tm_sec);

    return (s);
}

char * chaine (char c, int nb)
{
    static char s [300];
    int i;

    assert (nb < 300);
    for (i = 0; i < nb; i++) 	s[i] = c;

    s[nb] = '\0';

    return (s);
}


char * nom_fichier_ini (void)
{
    static char s [250];
    char * p;
    FILE * f;
    static char nom_fichier_ini_ [250] = "\0";

    // si la recherche a dj t ralise alors retourner directement le nom, pour gagner en vitesse
    if (nom_fichier_ini_ [0])
        return (nom_fichier_ini_);

    // Renvoie le nom du fichier exe avec l'extension ini
    // cherche d'abord dans le dossier en cours en cas de plusieurs projets
    // si pas trouv, alors renvoie le nom ini au mme endroit que l'exe

    GetModuleFileName (NULL, s, sizeof (s));

    p = strrchr(s, '.');
    if (p) strcpy (p + 1, "ini");

    // 1/ si l'ini existe dans le path actuel, alors on le prend.

    p = strrchr (s, '\\');
    if (p)
    {
        if ((f = fopen (p + 1, "r")) )
        {
            fclose (f);

            strcpy (nom_fichier_ini_, ".\\");
            strcat (nom_fichier_ini_, p + 1);
            return (nom_fichier_ini_);
        }
    }

    // 2/ Sinon renvoyer un nom de fichier ini  l'endroit de l'exe

    strcpy (nom_fichier_ini_, s);
    return (s);
}



void afficher_erreur_ORACLE (void)
{
	OCI_Error * err = OCI_GetLastError ();

	printf ("ERREUR ORACLE >> CODE %d, MSG %s\n",  OCI_ErrorGetOCICode (err), OCI_ErrorGetString (err) );
}

/*
   get_user_pwd_tns
   classique, dcompose la chane de connexion Oracle classique
   et la range dans les 3 variables user, pwd, tns
*/

int get_user_pwd_tns (char * _s, char * user, char * pwd, char * tns)
{
    // decode une chaine de connexion Oracle USER/PWD@TNS
    char * p, * ppwd;
    static char s [300];

    strcpy (s, _s);

    p = strchr (s, '/');
    if (! p) return (0);

    *p = '\0';
    strcpy (user, s);

    p++;
    ppwd = p;
    p = strchr (ppwd, '@');
    if (! p) return (0);

    *p = '\0';
    strcpy (pwd, ppwd);

    p++;
    strcpy (tns, p);

    return (1);
}



int ouvrir_cnx_BDD (char * chaine_cnx)
{
    static char user [100], pwd [100], tns [200];
    // ----------------------------------------------------------------
    //  Initialisation OCI &  Connexion  la BDD
    // ----------------------------------------------------------------

    if (! get_user_pwd_tns (chaine_cnx, user, pwd, tns) )
    {
        printf ("%s\n", chaine_cnx);
        printf (to_dos ("Erreur la chane TNS (%s) semble mal forme\nUtiliser le format user/pwd@TNS\n"), chaine_cnx);
        return (1);
    }


    if (! OCI_Initialize (NULL, NULL, OCI_ENV_DEFAULT | OCI_ENV_CONTEXT) )
    {
        printf (to_dos ("Erreur d'initialisation OCI, votre client oracle est-il bien install ?\n") );
        return (EXIT_FAILURE);
    }

    cn = OCI_ConnectionCreate (tns, user, pwd, OCI_SESSION_DEFAULT);
    if (! cn)
    {
        OCI_Error * err = OCI_GetLastError ();

        printf ("Erreur de connexion %d : %s\n", OCI_ErrorGetOCICode (err), to_dos ((char *) OCI_ErrorGetString (err)) );
        return (EXIT_FAILURE);
    }

    return (0);
}

char * lire_SQL (char * debut_SQL)
{
    static char result [MAX_LIG_SCE * 2];
    char * p;
    int L;

    memset (result, 0, sizeof(result) );

    strcpy (result, debut_SQL);
    p = strrchr (result, '\\');

    while (p)
    {
        // vrifier si c'est bien en fin de ligne
        L = strlen (result);
        assert (L < MAX_LIG_SCE);

        if (p + 3 > result + L)
        {
            fgets (p, MAX_LIG_SCE, fsce);
            p = strrchr (p, '\\');
            no_ligne++;  // synchro avec lecture principale du fichier scnario
        }
        else
            p = NULL;
    }

    p = strchr (result, '\n');
    if (p)  *p = '\0';

    return (result);
}


int lire_fichier_ini (void)
{
    memset (&d, 0, sizeof(d) );

    GetPrivateProfileString ("config", "client", "* client a definir *", d.client, sizeof (d.client), nom_fichier_ini() );
    GetPrivateProfileString ("config", "application", "* NOM CLIENT A RENSEIGNER *", d.application, sizeof (d.application), nom_fichier_ini() );
    GetPrivateProfileString ("config", "connexion_BDD", "", d.cnx_bdd, sizeof (d.cnx_bdd), nom_fichier_ini() );
    GetPrivateProfileString ("config", "titre_global", "* titre_global a definir *", d.titre_global, sizeof (d.titre_global), nom_fichier_ini() );

    if (! d.cnx_bdd [0]) return (1);

    return (0);
}

char * remplace_paths (char * alias)   // ex : {WST_OUT}\transfer.0025
{
    // remplace tous les alias d'un coup dans une chaine de caractres

    static char alias_ [500];
    static char s [500];
    static char sresult [500];
    char vrai_path [250];
    char * p, * pa, * pr;

    p = strchr (alias, '{' );

    if (! p)
    {
        strcpy (sresult, alias);
        return (sresult);
    }

    // on sait qu'on a au moins 1 alias dans la ligne
    sresult [0] = '\0';
    pr = sresult;

    strcpy (s, alias);
    p = s;

    while (*p)
    {
        if ((*p) == '{')
        {
            p++;
            pa = alias_;
            while ( (*p) != '}' )
            {
                *pa++ = *p++;
            }
            *pa = '\0';

            // Rechercher correspondance dans le fichier ini.
            GetPrivateProfileString ("alias", alias_, "*", vrai_path, sizeof (vrai_path), nom_fichier_ini() );
            if (vrai_path [0] == '*')
            {
                printf ("Alias %s non defini\n", alias_);
                return NULL;
            }

            strcpy (pr, vrai_path);
            pr = pr + strlen (vrai_path);
        }
        else
        {
            *pr++ = *p;
        }

        p++;
    }

    return (sresult);
}


char * remplace_var (char * alias)   // ex : select * from magasins where codemagasin = {CODE_MAG}
{
    // remplace tous les alias d'un coup dans une chaine de caractres

    static char alias_ [500];
    static char s [500];
    static char sresult [MAX_LIG_SCE * 2];
    char * p, * pa, * pr;

    memset (sresult, 0, sizeof(sresult) );
    p = strchr (alias, '{' );

    if (! p)
    {
        strcpy (sresult, alias);
        return (sresult);
    }

    // on sait qu'on a au moins 1 alias dans la ligne
    sresult [0] = '\0';
    pr = sresult;

    strcpy (s, alias);
    p = s;

    while (*p)
    {
        if ((*p) == '{')
        {
            p++;
            pa = alias_;
            while ( (*p) != '}' )
            {
                *pa++ = *p++;
            }
            *pa = '\0';

            // Rechercher et positionner la variable.
            strcpy (pr, get_valeur_var(alias_) );
            if (get_valeur_var(alias_) )   // si non NULL
               pr = pr + strlen (get_valeur_var(alias_) );
        }
        else
        {
            *pr++ = *p;
        }

        p++;
    }

    return (sresult);
}


int executer_scenario (void)
{
    char * p;
    static char s [MAX_LIG_SCE];
    static char sr [200];
    // rsultats SQL possibles
    int SQL_resultI;
    // double SQL_resultF;
    char SQL_resultS [100];
    // char SQL_resultD [20];
    int OK;
    int type_test = -1;
    OCI_Statement * st;

    nb_OK_sce =  nb_KO_sce = 0;

    //printf ("Debut EXECUTER SCENARIO\n");

    while (fgets (s, MAX_LIG_SCE, fsce) )
    {
        // printf ("> %s", s);
        p = strchr(s, '\n');
        if (p) *p = '\0';

        no_ligne++;

        if (s[0] == '#') continue;      // commentaires

        if (! strncmp (s, "TITLE", 5) )
        {
            strcpy (d.title, s + 6);
            fprintf (flog, "%s\n", chaine ('=', TRAIT) );
            fprintf (flog, "%s - %s\n", d.titre_global, d.title);
            fprintf (flog, "Application : %s 		Client : %s\n", d.application, d.client);
            fprintf (flog, "sur BDD %s\n", d.cnx_bdd);
            fprintf (flog, "date debut : %s\n", get_date_time () );
            fprintf (flog, "%s\n", chaine ('=', TRAIT) );
            continue;
        }

        if (! strncmp (s, "THEME", 5) )
        {
            fprintf (flog, ">> %s\n", s + 6);
            printf (">> %s\n", s + 6);
            continue;
        }

        if (! strncmp (s, "ID", 2) )
        {
            strcpy (r.test_id, s + 3);
            nb_tests++;
            continue;
        }

        if (! strncmp (s, "TXT", 3) )
            strcpy (r.test_lib, s + 4);

        if (! strncmp (s, "THEO", 4) )
            strcpy (r.result, remplace_var(s + 5) );

        if (! strncmp (s, "SQLI", 4) )
        {
            type_test = 1;	  // entier
            strcpy (r.SQL_resultI, remplace_var(lire_SQL (s + 5) ) );
            //printf ("sqli=%s\n", r.SQL_resultI);
            if (! OCI_Immediate (cn, r.SQL_resultI, OCI_ARG_INT, &SQL_resultI) )
            {
                printf ("erreur d'execution : ligne %d, TEST %s - sqlI %s\n", no_ligne, r.test_id, r.SQL_resultI);
                fprintf (flog, "erreur d'execution : ligne %d, TEST %s - sqlI %s\n", no_ligne, r.test_id, r.SQL_resultI);

                afficher_erreur_ORACLE ();

                SQL_resultI = -907;  // pour forcer un KO
            }

            continue;
        }

        if (! strncmp (s, "SQLSET", 6) )
        {
            p = strchr (s, '=' );
            if (p) *p = '\0';

            if (! OCI_Immediate (cn, MT(remplace_var(lire_SQL (p + 1))), OCI_ARG_TEXT, SQL_resultS) )
            {
                printf ("erreur d'execution SQLSET : ligne %d, TEST %s - sqlS %s\n", no_ligne, r.test_id, r.SQL_resultS);
                fprintf (flog, "erreur d'execution SQLSET : ligne %d, TEST %s - sqlS %s\n", no_ligne, r.test_id, r.SQL_resultS);

                afficher_erreur_ORACLE ();

                strcpy (SQL_resultS,  "?");  // pour forcer un KO
                set_valeur_var(s + 7, "");
            }
            else
              set_valeur_var(s + 7, SQL_resultS);

            continue;
        }


        if (! strncmp (s, "SQLS", 4) )
        {
            type_test = 2;	  // string
            strcpy (r.SQL_resultS, remplace_var(lire_SQL (s + 5) ) );
            //printf ("sqls=%s\n", r.SQL_resultS);
            if (! OCI_Immediate (cn, r.SQL_resultS, OCI_ARG_TEXT, SQL_resultS) )
            {
                printf ("erreur d'execution : ligne %d, TEST %s - sqlS %s\n", no_ligne, r.test_id, r.SQL_resultS);
                fprintf (flog, "erreur d'execution : ligne %d, TEST %s - sqlS %s\n", no_ligne, r.test_id, r.SQL_resultS);

                afficher_erreur_ORACLE ();

                strcpy (SQL_resultS,  "?");  // pour forcer un KO
            }

            continue;
        }

        if (! strncmp (s, "SQLX", 4) )
        {
            // pour executer un bloc SQL   begin ... end;  avec plein de scriptes  l'intrieur
            // ou lancer une PL.

            strcpy (r.SQL_resultX, remplace_var(lire_SQL (s + 5) ) );
            //printf ("sqlX=%s\n", r.SQL_resultX);

            st = OCI_StatementCreate (cn);

            if (! OCI_ExecuteStmt (st, MT(r.SQL_resultX) ) )
            {
                printf ("erreur d'execution : ligne %d, TEST %s - sqlX %s\n", no_ligne, r.test_id, r.SQL_resultX);
                fprintf (flog, "erreur d'execution : ligne %d, TEST %s - sqlX %s\n", no_ligne, r.test_id, r.SQL_resultX);

                afficher_erreur_ORACLE ();
            }

            OCI_StatementFree (st);
            continue;

            /*
             exemple de choses que j'ai testes
             SQLX drop table toto

             SQLX create table toto    \
                 (              \
                  c char(1),    \
                  i number(1)   \
                 )

             SQLX begin \
                    insert into toto values ('A', 0); \
                    insert into toto values ('B', 1); \
                    delete from toto where c = 'A';   \
                    commit;  \
                  end;

             SQLX begin \
                    TEST_DIRECTORY_FLUX_SK('DIRECTORY_FLUX');  \
                    TEST_DIRECTORY_FLUX_SK('UR_OUT');  \
                  end;
            */

        }


        if (! strncmp (s, "PAUSE", 5) )
        {
            printf ("*PAUSE* %s, (puis frappez sur la touche ENTREE)\n", remplace_paths (s + 6) );
            getchar ();
            continue;
        }

        if (! strncmp (s, "ASSERT", 6) )
        {
            OK = -999;
            strcpy (r.assert, s + 6);
            //printf ("@ assert : %s\n", r.assert);
            if (type_test == 1)  // vrifier entier
            {
                //printf ("@ =\n");

                if (r.assert[0] == '=')
                    OK = (atoi (r.result) == SQL_resultI);

                if (r.assert[0] == '<')
                    OK = (atoi (r.result) < SQL_resultI);

                if (r.assert[0] == '>')
                    OK = (atoi (r.result) > SQL_resultI);

                if (r.assert[0] == '!')
                    OK = (atoi (r.result) != SQL_resultI);
            }

            if (type_test == 2)  // vrifier chaine de caractres
            {
                if (r.assert[0] == '=')
                    OK = (! strcmp (r.result, SQL_resultS)) ;

                if (r.assert[0] == '<')
                    OK = (strcmp (r.result, SQL_resultS) < 0);

                if (r.assert[0] == '>')
                    OK = (strcmp (r.result, SQL_resultS) > 0);

                if (r.assert[0] == '!')
                    OK = (strcmp (r.result, SQL_resultS) != 0);
            }

            if (OK == -999)
            {
                fprintf (flog, "%-6.6s - %-60s : %s\n", r.test_id, r.test_lib, "NON EFFECTUE");
                printf (       "%-6.6s - %-60s : %s\n", r.test_id, r.test_lib, "NON EFFECTUE");
                OK = 0;
            }
            else
            {
                if (type_test == 1)
                    sprintf (sr, "%-6.6s - %s (theo %s, reel %d)", r.test_id, r.test_lib, r.result, SQL_resultI);

                if (type_test == 2)
                    sprintf (sr, "%-6.6s - %s (theo %s, reel %s)", r.test_id, r.test_lib, r.result, SQL_resultS);

                fprintf (flog, "%-100s : %s\n", sr,  OK ? "OK" : "KO");
                printf ("%-100s : %s\n", sr,  OK ? "OK" : "KO");
            }

            if (OK)
            {
                nb_OK_sce++;
                nb_OK++;
            }
            else
            {
                nb_KO_sce++;
                nb_KO++;
            }

        } // fin ASSERT

        if (! strncmp (s, "SYSTEM", 6) )   // lancer un bat, un exe, un ant
        {
            system (remplace_paths (s + 7) );
            continue;
        }

        if (! strncmp (s, "ECHO", 4) )     // afficher ce que l'on fait, exemple devant un SQLX
        {
            printf ("%s\n", remplace_var(s + 5) );
            continue;
        }

        if (! strncmp (s, "SET", 3) )     // afficher ce que l'on fait, exemple devant un SQLX
        {
            //printf ("%s\n", s + 3);
            p = strchr (s, '=' );
            if (p) *p = '\0';

            set_valeur_var(s + 4, remplace_var(p + 1) );

           // printf (">SET variable %s=%s\n", s + 4, p + 1);
           // printf (">get_variable %s\n", get_valeur_var(s + 4));
            continue;
        }


    } // fin while fgets

    //printf ("Fin EXECUTER SCENARIO\n");
    return (0);
}



int main (int argc, char * argv [])
{
    char nom_fichier_log [255];
    clock_t temps_depart;
    char * p;

    // afficher le temps de traitement  la fin.
    temps_depart = clock ();

    printf (to_dos("SK_TESTS %s - Petit outil de test fait  la maison - par Sad Koudache\n"), VERSION );

  //  printf ("%s\n ", remplace_paths("{UR_OUT}\\toto.txt,{WST_OUT}\\titi.txt") );
    printf ("%s\n", nom_fichier_ini () );

    if (argc != 2)
    {
        printf ("Usage : sk_tests nom_scenario.sce\n");
        return (1);
    }

    fsce = fopen (argv [1], "rt");
    if (! fsce)
    {
        printf ("erreur d'ouverture du fichier scenario %s\n", argv [1]);
        return (1);
    }

    strcpy (nom_fichier_log, argv [1]);
    p = strrchr(nom_fichier_log, '.');
    if (p)
    {
        strcpy (p, ".LOG");
    }

    flog = fopen (nom_fichier_log, "at");
    if (! flog)
    {
        fclose (fsce);
        printf ("erreur d'ouverture du fichier log %s\n", nom_fichier_log);
        return (1);
    }

    if (lire_fichier_ini () )
    {
        printf ("Erreur de lecture section INIT\n");
        return (1);
    }

    if (ouvrir_cnx_BDD (d.cnx_bdd) )
    {
        fprintf (flog, "Erreur de connexion  la BDD\n");
        fclose (flog);
        fclose (fsce);
        return (1);
    }

    // un peu de chrono pour changer
    printf (to_dos("\nConnect en %6.2lf secondes\n"),  ((double) (clock () - temps_depart) / CLOCKS_PER_SEC));
    temps_depart = clock ();

    printf ("\ndate debut : %s\n", get_date_time () );

    nb_OK = nb_KO = nb_tests = 0;

    executer_scenario ();

    fprintf (flog, "%s\n", chaine ('-', TRAIT) );
    fprintf (flog, "date fin : %s\n", get_date_time () );
    fprintf (flog, "nb tests : %d,    dont KO : %d (%3.2lf%%) et OK : %d (%3.2lf%%)\n", nb_tests, nb_KO, (nb_KO * 100.0)/nb_tests, nb_OK, (nb_OK * 100.0)/nb_tests);

    printf ("date fin : %s\n", get_date_time () );
    printf ("nb tests : %d,    dont KO : %d (%3.2lf%%) et OK : %d (%3.2lf%%)\n", nb_tests, nb_KO, (nb_KO * 100.0)/nb_tests, nb_OK, (nb_OK * 100.0)/nb_tests);

    fprintf (flog, "%s\n\n", chaine ('=', TRAIT) );

    // Fermeture de la connexion et nettoyages divers

    fclose (fsce);
    fclose (flog);

    OCI_ConnectionFree (cn);
    OCI_Cleanup ();

    printf (to_dos("\nDure traitement %6.2lf secondes\n"),  ((double) (clock () - temps_depart) / CLOCKS_PER_SEC));

    return (0);   // tout s'est bien pass.
}

